package subcluens.operations

import subcluens.datastructure.DataTensor
import scala.annotation.tailrec

/**
  * Combines the regroup operation for each dimension and applies them until convergence.
  */
object RegroupAll {
  @tailrec
  def apply(dm: DataTensor[Int, Int, Int]): DataTensor[Int, Int, Int] = {
    val regrouped = ReGroupTubes.performOperation(ReGroupCols.performOperation(ReGroupRows.performOperation(dm)))
    if (regrouped != dm && regrouped.encodingCosts < dm.encodingCosts) {
      apply(regrouped)
    } else {
      dm
    }
  }
}

